"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Metadata = exports.Data = exports.Creator = void 0;
const utils_1 = require("./utils");
const borsh_1 = require("@race-foundation/borsh");
class Creator {
    constructor(fields) {
        Object.assign(this, fields);
    }
}
__decorate([
    (0, borsh_1.field)(utils_1.publicKeyExt)
], Creator.prototype, "address", void 0);
__decorate([
    (0, borsh_1.field)('bool')
], Creator.prototype, "verified", void 0);
__decorate([
    (0, borsh_1.field)('u8')
], Creator.prototype, "share", void 0);
exports.Creator = Creator;
class Data {
    constructor(fields) {
        Object.assign(this, fields);
    }
}
__decorate([
    (0, borsh_1.field)('string')
], Data.prototype, "name", void 0);
__decorate([
    (0, borsh_1.field)('string')
], Data.prototype, "symbol", void 0);
__decorate([
    (0, borsh_1.field)('string')
], Data.prototype, "uri", void 0);
__decorate([
    (0, borsh_1.field)('u16')
], Data.prototype, "sellerFeeBasisPoints", void 0);
__decorate([
    (0, borsh_1.field)((0, borsh_1.option)((0, borsh_1.array)((0, borsh_1.struct)(Creator))))
], Data.prototype, "creators", void 0);
exports.Data = Data;
class Metadata {
    constructor(fields) {
        Object.assign(this, fields);
    }
    static deserialize(data) {
        return (0, borsh_1.deserialize)(Metadata, new Uint8Array(data.buffer));
    }
}
__decorate([
    (0, borsh_1.field)('u8')
], Metadata.prototype, "key", void 0);
__decorate([
    (0, borsh_1.field)(utils_1.publicKeyExt)
], Metadata.prototype, "updateAuthority", void 0);
__decorate([
    (0, borsh_1.field)(utils_1.publicKeyExt)
], Metadata.prototype, "mint", void 0);
__decorate([
    (0, borsh_1.field)((0, borsh_1.struct)(Data))
], Metadata.prototype, "data", void 0);
exports.Metadata = Metadata;
//# sourceMappingURL=metadata.js.map