var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { publicKeyExt } from './utils';
import { deserialize, field, array, struct, option } from '@race-foundation/borsh';
export class Creator {
    constructor(fields) {
        Object.assign(this, fields);
    }
}
__decorate([
    field(publicKeyExt)
], Creator.prototype, "address", void 0);
__decorate([
    field('bool')
], Creator.prototype, "verified", void 0);
__decorate([
    field('u8')
], Creator.prototype, "share", void 0);
export class Data {
    constructor(fields) {
        Object.assign(this, fields);
    }
}
__decorate([
    field('string')
], Data.prototype, "name", void 0);
__decorate([
    field('string')
], Data.prototype, "symbol", void 0);
__decorate([
    field('string')
], Data.prototype, "uri", void 0);
__decorate([
    field('u16')
], Data.prototype, "sellerFeeBasisPoints", void 0);
__decorate([
    field(option(array(struct(Creator))))
], Data.prototype, "creators", void 0);
export class Metadata {
    constructor(fields) {
        Object.assign(this, fields);
    }
    static deserialize(data) {
        return deserialize(Metadata, new Uint8Array(data.buffer));
    }
}
__decorate([
    field('u8')
], Metadata.prototype, "key", void 0);
__decorate([
    field(publicKeyExt)
], Metadata.prototype, "updateAuthority", void 0);
__decorate([
    field(publicKeyExt)
], Metadata.prototype, "mint", void 0);
__decorate([
    field(struct(Data))
], Metadata.prototype, "data", void 0);
//# sourceMappingURL=metadata.js.map