/// <reference types="node" />
import { PublicKey } from '@solana/web3.js';
/**
 * A partial port of Metaplex's Metadata layout.
 *
 * Metaplex library introduces extra dependencies that requires node
 * polyfill, And we only use a small set of its features.
 */
export interface IMetadata {
    key: number;
    updateAuthority: PublicKey;
    mint: PublicKey;
    data: Data;
}
export interface ICreator {
    address: PublicKey;
    verified: boolean;
    share: number;
}
export interface IData {
    name: string;
    symbol: string;
    uri: string;
    sellerFeeBasisPoints: number;
    creators: ICreator[] | undefined;
}
export declare class Creator implements ICreator {
    address: PublicKey;
    verified: boolean;
    share: number;
    constructor(fields: ICreator);
}
export declare class Data implements IData {
    name: string;
    symbol: string;
    uri: string;
    sellerFeeBasisPoints: number;
    creators: ICreator[] | undefined;
    constructor(fields: IData);
}
export declare class Metadata implements IMetadata {
    key: number;
    updateAuthority: PublicKey;
    mint: PublicKey;
    data: Data;
    constructor(fields: IMetadata);
    static deserialize(data: Buffer): Metadata;
}
//# sourceMappingURL=metadata.d.ts.map